您的位置:首页 > 其它

LeetCode 292.Nim Game 解题报告

2016-09-14 13:27 447 查看

LeetCode 292.Nim Game 解题报告

题目描述

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

示例

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

限制条件

没有明确给出。

解题思路

题目虽然很长,但看完了认真想想会发现其实题目很简单。

要注意例子里已经说了当只有4个石头的时候,无论你是拿多少个,你都是输,因为剩下的石头都能被对手一次拿完。既然自己先拿时,剩下4个会输,那同样的,我们可以利用这一点,比如5个时,自己先拿1个,剩下4个给对手;6个时,自己先拿2个,剩下4个给对手;7个时,自己先拿3个,剩下4个给对手,这样我们都是能赢的,但是如果是有8个呢?这时情况又会变成了,无论自己拿多少个,对手都能给我们留4个,所以我们必输。12个的情况类似,对手能留给我们8个,继而按照8个的情况,我们输。因此我们可以得出规律:如果石头的个数是4的倍数,我们一定会输,所以代码就是简单的一行判断N是不是4的倍数。(这么简单真是不敢相信)

代码

class Solution {
public:
bool canWinNim(int n) {
return n % 4 != 0;
}
};


总结

做题时先尝试找找规律,不要把问题想得太复杂。通过之后,查看了官方参考答案,解释就是我上面的那样。

每天一水题。填坑之旅继续进行,加油!
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: